Subject: Re: [PATCHv4] gitweb: make static files accessible with PATH_INFO

From: Jakub Narebski <[email-masked]>
Date: Wed, 28 Jan 2009 02:47:24 +0100

On Wed, 28 Jan 2009, Junio C Hamano wrote:
> Giuseppe Bilotta <[email-masked]> writes:
> 
> > When PATH_INFO is defined,

I other words: when using PATH_INFO gitweb URL

> > static files such as the default CSS or the 
> > shortcut icon are not accessible beyond the summary page (e.g. in
> > shortlog or commit view).

To be more exact: if static files, such as the default CSS (and also
other stylesheets, if defined), the gitweb favicon / shortcut icon,
or the gitweb logo locations (URIs) are defined using relative URL
with relative path (and default Makefile rule to generate gitweb.cgi
uses basenames like 'gitweb.css', which are relative paths) _THEN_
those static files are not accessible beyond 'summary' and projects
list view (e.g. in 'shortlog' or 'commit' view).

> >
> > Fix this by adding a <base> tag pointing to the script's own URL.

Which defines base URL for all relative links in gitweb.

/Note that this makes the document hierarchy non-portable, but I don't
think we care.../

> >
> > Signed-off-by: Giuseppe Bilotta <[email-masked]>
> > ---
> >  gitweb/gitweb.perl |    5 +++++
> >  1 files changed, 5 insertions(+), 0 deletions(-)
> >
> > diff --git a/gitweb/gitweb.perl b/gitweb/gitweb.perl
> > index 931db4f..55e3081 100755
> > --- a/gitweb/gitweb.perl
> > +++ b/gitweb/gitweb.perl
> > @@ -2901,6 +2901,11 @@ sub git_header_html {
> >  <meta name="robots" content="index, nofollow"/>
> >  <title>$title</title>
> >  EOF
> > +# the stylesheet, favicon etc urls won't work correctly with path_info unless we
> > +# set the appropriate base URL

+# the stylesheet, favicon, etc URLs won't work correctly with path_info,
+# unless we set the appropriate base URL

By the way, I think those comments should be indented aligned to
accompanying code, but this is issue of separate whitespace cleanup,
independent of the issue this commit tries to solve.

> > +	if ($ENV{'PATH_INFO'}) {
> > +		print "<base href=\"$my_url\" />\n";
> > +	}
> 
> Perhaps this is a stupid question, but is $my_url already safe to include
> in the output without any further quoting at this point in the codepath?

Hmmmm... to be safe we probably should use either esc_url($my_url) here
(like in git_feed subroutine).

-- 
Jakub Narebski
Poland